// asm.c    parser for asm-summer 2018

#include "compile.h"

#define eqs(s1,s2)    (strcmp(s1,s2) == 0)

void mylex2(void){
	mylex();
	if(tok == tkEOF) printf("eof ");
	else printf("%s ",tokstring);
}

int num(void){
	if(tok == 11){ 	// match number token
		mylex2();	// next token
		return 1;
	}
	return 0;
}

int reg(void){
	if(tok != 10) return 0;				// check token type
	if(tokstring[0] != 'R') return 0;	// check 'R'
	mylex2();							// next token
	return 1;
}

int isop(void){
	return eqs(tokstring, "ADD") || eqs(tokstring, "SUB") ||
	       eqs(tokstring, "SET") ;
}

int oprnd(void){
	if(reg() != 0){
		if(tok == 66){		// match ,
			mylex2();		// next token
			return num();
		}else
			return 1;
	}
	return 1;
}

int op(void){
	if( isop() ){
		mylex2();
		return 1;
	}
	return 0;
}

int op2(void){
	if( op() ){
		reg();
		return 1;
	}else if( eqs(tokstring, "JMP") ){
		mylex2();
		return 1;
	}
	return 0;
}

int arg(void){
	if( reg() ){
		op();
		reg();
		return 1;
	}else if( num() ){
		op2();
		return 1;
	}
	return 0;
}

int asm(void){
	if( tok == tkEOF ) return 1;
	if( arg() ){
		asm();
	}
	return 0;
}


